/*
   Your program should read an integer parameter n off of the command line
   and then draw n equilateral triangles around the circumference of the
   unit circle.

   You must place the n triangles around the circumference of the circle
   by using OpenGL transformations of the basic triangle defined below.
   You should not change the function model().
*/
#include <math.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif


/* Prototype for the display callback function */
void display( void );

const float DEG2RAD = 3.14159/180;


int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Problem 1");  /* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */

   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-1.0, 1.0, -1.0, 1.0); /* world window */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of our model down the graphics pipeline. */
void model( void )
{
   /* Here are the primitives that make up our basic model. */
   glBegin(GL_LINE_LOOP);
      glVertex2f(0.0,    0.0); // an equlateral triangle with side length 1
      glVertex2f(0.866,  0.5);
      glVertex2f(0.866, -0.5);
   glEnd();
}//model()


/* The display() callback function */
void display( void )
{
   int i;
   float length, angle;

   glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */

   glColor3f(1.0, 0.0, 0.0);      /* draw in red */

   glLoadIdentity();
   glBegin(GL_LINE_LOOP);         /* draw the unit circle */
     for (i = 0; i < 360; i++)
     {
        float degInRad = i*DEG2RAD;
        glVertex2f( cos(degInRad), sin(degInRad) );
     }
   glEnd();

   glColor3f(0.0, 0.0, 0.0);      /* draw in black */


   // Here is one instance of the model,
   // to show you what it looks like.
   model();


   glFlush(); /* clear buffers */
}//display()