/*

*/
#include <math.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/* Prototype for the display callback function */
void display( void );

int main(int argc, char** argv)
{
   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_SINGLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(500,500);    /* 500 x 500 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   glutCreateWindow("Problem 2");  /* window title */
   glutDisplayFunc(display);       /* display callback invoked when window opened */

   /* Initialize OpenGL state */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */

   /* set up viewing */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(-10.0, 10.0, -10.0, 10.0); /* world window */
   glMatrixMode(GL_MODELVIEW);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of our model down the graphics pipeline. */
void model( void )
{  /* Here are the primitives that make up our basic model. */
   glBegin(GL_LINE_LOOP);
      glVertex2f( 1.0,  0.0);   // a hexagon inscribed in the unit circle
      glVertex2f( 0.5,  0.866);
      glVertex2f(-0.5,  0.866);
      glVertex2f(-1.0,  0.0);
      glVertex2f(-0.5, -0.866);
      glVertex2f( 0.5, -0.866);
   glEnd();
}//model()


/* The display() callback function */
void display( void )
{
   glClear(GL_COLOR_BUFFER_BIT);  /* clear the window */

   glColor3f(1.0, 0.0, 0.0);      /* draw in red */



   // Here is one instance of the model,
   // to show you what it looks like.
   model();



   glFlush(); /* clear buffers */
}//display()