/*

*/
#include <math.h>

#if defined _WIN32 || defined _WIN64
#  include <windows.h>
#endif

#ifdef __APPLE__
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

#include "glui.h"

#define PI 3.14159265

int windowHeight;    // this is set by the glut reshape() callback function
int windowWidth;     // this is set by the glut reshape() callback function

#define sliderInit 0.5
float sliderValue = sliderInit;  // this is set by the glui slider() callback function

/* Prototypes for the GLUT callback functions */
void display( void );
void reshape(int, int);
void slider(float);


int main(int argc, char** argv)
{
   int window;

   /* Standard GLUT initialization */
   glutInit(&argc,argv);
   glutInitDisplayMode (GLUT_DOUBLE | GLUT_RGB); /* default, not needed */
   glutInitWindowSize(600,620);    /* 600 x 620 pixel window */
   glutInitWindowPosition(50,50);  /* place window near top left of display */
   window = glutCreateWindow("Movie");
   glutDisplayFunc(display);
   glutReshapeFunc(reshape);

   /* Initialize OpenGL state */
   glClearColor(1.0, 1.0, 1.0, 1.0); /* white background */

   // parent window, x, y, width, height, initial value, callback function
   gluiHorizontalSlider(window, 10, 0, -10, 20, sliderInit, slider);

   /* Enter event loop */
   glutMainLoop();

   return 0;  /* we never get here */
}//main()


/* This function sends one instance of our model down the graphics pipeline. */
void model( void )
{
   /* Here are the primitives that make up our basic model. */
   glBegin(GL_LINE_LOOP);
      glVertex2f( 1.0,  1.0);  // a square
      glVertex2f(-1.0,  1.0);
      glVertex2f(-1.0, -1.0);
      glVertex2f( 1.0, -1.0);
   glEnd();
}//model()


/* The display() callback function */
void display( void )
{
   int viewportSize, viewportBottom;
   double maxAngle;
   int n;

   glClear(GL_COLOR_BUFFER_BIT); /* clear the window */

   glColor3f(1.0, 0.0, 0.0);     /* draw in red */

   // compute the dimensions for the four viewports




   // use the slider value to determine the maximum angle by which
   // to rotate an instance of the model
   maxAngle = sliderValue*360.0;


   /* set viewport 1 */
   glViewport(  );

   /* set up a world wndow for viewport 1 */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(  );

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // your code for viewport 1




   /* set viewport 2 */
   glViewport(  );

   /* set up a world wndow for viewport 2 */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(   );

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // your code for viewport 2



   /* set viewport 3 */
   glViewport(  );

   /* set up a world wndow for viewport 3 */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(   );

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // your code for viewport 3




   /* set viewport 4 */
   glViewport(  );

   /* set up a world wndow for viewport 4 */
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(    );

   /* draw the image for this viewport */
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();

   // your code for viewport 4



   glutSwapBuffers();  // glui needs double buffering!
}//display()


/* The reshape() callback function */
void reshape(int width, int height)
{
   windowWidth  = width;
   windowHeight = height;

   //printf("We got a \"reshape(%d, %d)\" event\n", width, height);

   gluiReshape(width, height);  // notice the difference here
}//reshape()


/* glui slider callback function */
void slider(float value)
{
   sliderValue = value;

   //printf("We got a \"slider(%f)\" event\n", value);

   glutPostRedisplay();  // notice the difference here
}//slider()